package org.nuiton.jredmine.plugin;

/*
 * #%L
 * JRedmine :: Maven plugin
 * $Id: SkipOrRunOnlyOnceAware.java 411 2013-08-08 12:31:31Z tchemit $
 * $HeadURL: http://svn.nuiton.org/svn/jredmine/tags/jredmine-1.6/jredmine-maven-plugin/src/main/java/org/nuiton/jredmine/plugin/SkipOrRunOnlyOnceAware.java $
 * %%
 * Copyright (C) 2009 - 2013 CodeLutin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */

/**
 * Contract to place on mojo which can be run only once, or only on root module.
 *
 * @author tchemit <chemit@codelutin.com>
 * @since 1.6
 */
public interface SkipOrRunOnlyOnceAware {

    String getSkipProperty();

    boolean isGoalSkip();

    boolean isRunOnce();

    boolean isRunOnlyOnRoot();

    boolean checkRunOnceDone();

    boolean isRunOnceDone();
}
